## lucene++ 3.0.4

=== CMakeLists.txt ===
project(lucene++-base)

####################################
# VERSION information
#These versions match the Lucene version
SET(LUCENE++_VERSION_MAJOR "3")
SET(LUCENE++_VERSION_MINOR "0")
SET(LUCENE++_VERSION_REVISION "3")
SET(LUCENE++_VERSION_PATCH "4")

# SOVERSION information
#Must be incremented for releases if the api is not backwards compatible
SET(LUCENE++_SOVERSION "0")

#derived versions
MATH(EXPR LUCENE++_INT_VERSION "(${LUCENE++_VERSION_MAJOR} * 1000000) + (${LUCENE++_VERSION_MINOR} * 10000) + (${LUCENE++_VERSION_REVISION} * 100) + (${LUCENE++_VERSION_PATCH} * 1)" )
SET(LUCENE++_VERSION "${LUCENE++_VERSION_MAJOR}.${LUCENE++_VERSION_MINOR}.${LUCENE++_VERSION_REVISION}.${LUCENE++_VERSION_PATCH}")
MESSAGE(${LUCENE++_INT_VERSION})
MESSAGE(${LUCENE++_VERSION})

####################################

####################################
# Build system options and includes
####################################
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)
#build policies
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# include specific modules
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

#if setup using the Toolchain-llvm.cmake file, then use llvm...
IF ( ENABLE_LLVM )
  INCLUDE (Toolchain-llvm)
ENDIF ( ENABLE_LLVM )

#define options...
INCLUDE (Lucene++Docs)
INCLUDE (FindThreads)
INCLUDE (TestCXXAcceptsFlag)
ENABLE_TESTING()

#Single output directory for building all executables and libraries.
SET(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE PATH "Executable Output Directory" FORCE)
SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE PATH "Library Output Directory" FORCE)
####################################

####################################
#user specified build options
####################################
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ELSE(NOT CMAKE_BUILD_TYPE)
    MESSAGE( "Compiling as ${CMAKE_BUILD_TYPE}" )
ENDIF(NOT CMAKE_BUILD_TYPE)

OPTION(ENABLE_PACKAGING
  "create build scripts for creating lucene++ packages"
  OFF)
OPTION(ENABLE_NEDMALLOC
  "use nedmalloc for memory allocations"
  OFF)
OPTION(LUCENE_USE_STATIC_BOOST_LIBS
  "use static boost libraries "
  OFF)
OPTION(ENABLE_CYCLIC_CHECK
  "enable cyclic checking "
  OFF)

#install path options
SET(LIB_DESTINATION "lib" CACHE STRING "Define lib output directory name")

IF ( ENABLE_NEDMALLOC )
  SET(DEFINE_USE_NEDMALLOC "define")
ELSE ( ENABLE_NEDMALLOC )
  SET(DEFINE_USE_NEDMALLOC "undef")
ENDIF ( ENABLE_NEDMALLOC )

IF ( ENABLE_STANDARD_ALLOCATOR )
  SET(DEFINE_USE_ALLOCATOR "undef")
ELSE ( ENABLE_STANDARD_ALLOCATOR )
  SET(DEFINE_USE_ALLOCATOR "define")
ENDIF ( ENABLE_STANDARD_ALLOCATOR )

IF ( ENABLE_CYCLIC_CHECK )
  SET(DEFINE_USE_CYCLIC_CHECK "define")
ELSE ( ENABLE_CYCLIC_CHECK )
  SET(DEFINE_USE_CYCLIC_CHECK "undef")
ENDIF ( ENABLE_CYCLIC_CHECK )
####################################

####################################
# PLATFORM specific options
####################################
#add a debug build postfix
if(WIN32 OR WIN64)
 set(CMAKE_DEBUG_POSTFIX "d")
endif(WIN32 OR WIN64)

if(NOT MSVC AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")
        add_definitions(-fPIC)
endif(NOT MSVC AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")

INCLUDE(MacroCheckGccVisibility)
MACRO_CHECK_GCC_VISIBILITY(LPP_HAVE_GXXCLASSVISIBILITY)
if ( LPP_HAVE_GXXCLASSVISIBILITY )
	ADD_DEFINITIONS(-DLPP_HAVE_GXXCLASSVISIBILITY)
endif()

IF(CYGWIN)
  ADD_DEFINITIONS(-D__LARGE64_FILES)
ENDIF(CYGWIN)

#set ansi mode 
SET(ENABLE_ANSI_MODE OFF)
IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(ENABLE_ANSI_MODE ON)
  
  #exceptions:
  IF(MINGW OR CYGWIN)
    SET(ENABLE_ANSI_MODE OFF)
  ENDIF(MINGW OR CYGWIN)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)
IF ( CMAKE_COMPILER_IS_GNUCC )
   IF( ENABLE_ANSI_MODE )
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ansi")
   ENDIF ( ENABLE_ANSI_MODE )
ENDIF(CMAKE_COMPILER_IS_GNUCC) 

####################################
#find boost
####################################
SET(Boost_USE_STATIC_LIBS   ${LUCENE_USE_STATIC_BOOST_LIBS})
SET(Boost_USE_MULTITHREADED ON)
#Boost 1.38 required for bug fixes in basic_streambuf. 
#The following line fails in earlier builds, so if altered, may allow older versions of boost:
#boost::gregorian::date date = parser.parse_date(paddedDate.c_str(), dateFormat->c_str(), svp);
find_package( Boost 1.38.0 COMPONENTS date_time filesystem iostreams regex system thread unit_test_framework REQUIRED)
IF (Boost_FOUND)
  MESSAGE( STATUS "boost found: includes in ${Boost_INCLUDE_DIRS}, library in ${Boost_LIBRARY_DIRS}")
  SET(LUCENE_BOOST_LIBS 
    ${Boost_FILESYSTEM_LIBRARY_RELEASE}
    ${Boost_IOSTREAMS_LIBRARY_RELEASE}
    ${Boost_REGEX_LIBRARY_RELEASE}
    ${Boost_SYSTEM_LIBRARY_RELEASE}
    ${Boost_THREAD_LIBRARY_RELEASE})
ENDIF (Boost_FOUND)

####################################
# Pre-Compiled headers
####################################
INCLUDE(PCHSupport)

#todo: make this optional and make it possible to add more headers - like boost threads


#################################
# generate Config.h
#################################

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/include/Config.h.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/include/Config.h @ONLY)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/include)

####################################
# The subdirs
####################################
#include sub-projects
ADD_SUBDIRECTORY (src/core)
ADD_SUBDIRECTORY (src/contrib)
ADD_SUBDIRECTORY (src/demo EXCLUDE_FROM_ALL)
ADD_SUBDIRECTORY (src/test)

#################################
# install pkg-config file
#################################
IF(NOT WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/liblucene++.pc.cmake
                 ${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/liblucene++-contrib.pc.cmake
                 ${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc @ONLY)

  install(FILES
          ${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc
          ${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc
          DESTINATION ${LIB_DESTINATION}/pkgconfig )
ENDIF(NOT WIN32)

####################################
# Custom targets
####################################
#add uninstall command
CONFIGURE_FILE(
  "${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")


####################################
# Finalise build script
####################################

#this must go last...
IF (ENABLE_PACKAGING)
  INCLUDE(CreateLucene++Packages)
ENDIF ( ENABLE_PACKAGING)

=== wscript ===
#############################################################################
## Copyright (c) 2009-2011 Alan Wright. All rights reserved.
## Distributable under the terms of either the Apache License (Version 2.0)
## or the GNU Lesser General Public License.
#############################################################################

import sys
import os
from copy import copy
import Options
from Configure import conf
from TaskGen import feature, after
import Task

APPNAME='Lucene++'
VERSION='3.0.4.0'

top = '.'
out = 'bin'

source_patterns = [
    '**/*.c',
    '**/*.cpp'
]

lucene_source_dirs = [
    'src/core/analysis',
    'src/core/document',
    'src/core/index',
    'src/core/queryparser',
    'src/core/search',
    'src/core/store',
    'src/core/util'
]

lucene_contrib_source_dirs = [
    'src/contrib/analyzers',
    'src/contrib/highlighter',
    'src/contrib/memory',
    'src/contrib/snowball'
]

lucene_include_dirs = [
    'include',
    'src/core/include',
    'src/contrib/include',
    'src/contrib/snowball/libstemmer_c/include',
    'src/core/util/md5',
    'src/core/util/nedmalloc',
    'src/core/util/unicode'
]

tester_source_dirs = [
    'src/test/analysis',
    'src/test/contrib',
    'src/test/document',
    'src/test/index',
    'src/test/queryparser',
    'src/test/search',
    'src/test/store',
    'src/test/util',
    'src/test/main'
]

tester_include_dirs = [
    'include',
    'src/core/include',
    'src/contrib/include',
    'src/test/include'
]


def options(opt):
    opt.tool_options("boost")
    opt.tool_options('compiler_cxx')
    #opt.tool_options('clang', tooldir = 'build')
    #opt.tool_options('gch', tooldir = 'build')
    opt.add_option(
        '--debug',
        default = False,
        action = "store_true",
        help ='debug build no optimization, etc.',
        dest = 'debug')

    opt.add_option(
        '--static',
        default = False,
        action = "store_true",
        help ='fully static build',
        dest = 'static')


def configure(conf):
    conf.check_tool('g++')
    conf.check_tool('gcc')
    conf.check_cc(lib = 'z', mandatory = True)
    conf.check_cc(lib = 'pthread', mandatory = True)
    conf.check_tool('boost')
    #conf.check_tool('clang', 'build')
    #conf.check_tool('gch', 'build')
    conf.check_boost(
        static = 'onlystatic',
        lib = ['filesystem', 'thread', 'regex', 'system', 'date_time', 'iostreams', 'unit_test_framework']
    )


def build(bld):
    target_type = 'cstlib' if Options.options.static else 'cshlib'
    debug_define = '_DEBUG' if Options.options.debug else 'NDEBUG'
    if Options.options.debug:
         compile_flags = ['-O0', '-g']
    else:
         compile_flags = ['-O2']
    lucene_sources = []
    for source_dir in lucene_source_dirs:
        source_dir = bld.path.find_dir(source_dir)
        lucene_sources.extend(source_dir.ant_glob(source_patterns))

    bld(
        name = 'lucene++',
        features = ['cxx', 'c'] + [target_type],
        source = [source.relpath_gen(bld.path) for source in lucene_sources],
        target = 'lucene++',
        pch = 'src/core/include/LuceneInc.h',
        includes = lucene_include_dirs + bld.env["CPPPATH_BOOST"],
        cflags = compile_flags,
        cxxflags = compile_flags,
        defines = ['LPP_BUILDING_LIB', 'LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD Z'
        )

    lucene_contrib_sources = []
    for source_dir in lucene_contrib_source_dirs:
        source_dir = bld.path.find_dir(source_dir)
        lucene_contrib_sources.extend(source_dir.ant_glob(source_patterns))

    bld(
        name = 'lucene_contrib',
        features = ['cxx', 'c'] + [target_type],
        source = [source.relpath_gen(bld.path) for source in lucene_contrib_sources],
        target = 'lucene_contrib',
        pch = 'src/contrib/include/ContribInc.h',
        includes = lucene_include_dirs + bld.env["CPPPATH_BOOST"],
        cflags = compile_flags,
        cxxflags = compile_flags,
        defines = ['LPP_BUILDING_LIB', 'LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD Z',
        use = 'lucene++'
        )

    tester_sources = []
    for source_dir in tester_source_dirs:
        source_dir = bld.path.find_dir(source_dir)
        tester_sources.extend(source_dir.ant_glob(source_patterns))

    bld(
        name = 'lucene_tester',
        features = ['cxx', 'c', 'cprogram'],
        source = [source.relpath_gen(bld.path) for source in tester_sources],
        target = 'lucene_tester',
        pch = 'src/test/include/TestInc.h',
        includes = tester_include_dirs + bld.env["CPPPATH_BOOST"],
        cflags = compile_flags,
        cxxflags = compile_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + ['LPP_EXPOSE_INTERNAL'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS BOOST_UNIT_TEST_FRAMEWORK PTHREAD Z',
        use = 'lucene++ lucene_contrib'
        )

    bld(
        name = 'deletefiles',
        features = ['cxx', 'c', 'cprogram'],
        source = bld.path.find_resource('src/demo/deletefiles/main.cpp').relpath_gen(bld.path),
        target = 'deletefiles',
        includes = ['include'] + bld.env["CPPPATH_BOOST"],
        cflags = compile_flags,
        cxxflags = compile_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD Z',
        use = 'lucene++'
        )

    bld(
        name = 'indexfiles',
        features = ['cxx', 'c', 'cprogram'],
        source = bld.path.find_resource('src/demo/indexfiles/main.cpp').relpath_gen(bld.path),
        target = 'indexfiles',
        includes = ['include'] + bld.env["CPPPATH_BOOST"],
        cflags = compile_flags,
        cxxflags = compile_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD Z',
        use = 'lucene++'
        )

    bld(
        name = 'searchfiles',
        features = ['cxx', 'c', 'cprogram'],
        source = bld.path.find_resource('src/demo/searchfiles/main.cpp').relpath_gen(bld.path),
        target = 'searchfiles',
        includes = ['include'] + bld.env["CPPPATH_BOOST"],
        cflags = compile_flags,
        cxxflags = compile_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD Z',
        use = 'lucene++'
        )

=== scripts/llvm/wscript ===
#############################################################################
## Copyright (c) 2009-2011 Ben van Klinken. All rights reserved.
## Distributable under the terms of either the Apache License (Version 2.0)
## or the GNU Lesser General Public License.
#############################################################################

import sys
import os
from copy import copy
import Options
import TaskGen
from Configure import conf
from TaskGen import feature, after
#import Task, ccroot

APPNAME='Lucene++'
VERSION='3.0.2'

top = '../../'
out = 'bin'

source_patterns = '**/*.(c|cpp)'

lucene_source_dirs = [
    top + 'src/core/analysis',
    top + 'src/core/document',
    top + 'src/core/index',
    top + 'src/core/queryparser',
    top + 'src/core/search',
    top + 'src/core/store',
    top + 'src/core/util'
]

boost_defines = [
  'BOOST_BUILD_THREAD_DLL',
  'BOOST_BUILD_FILESYSTEM_DLL',
  'BOOST_BUILD_REGEX_DLL',
  'BOOST_BUILD_DATE_TIME_DLL',
  'BOOST_BUILD_IOSTREAMS_DLL',
]
boost_sources_dirs = [
  'libs/thread/src',
  'libs/filesystem/src',
  'libs/regex/src',
  'libs/date_time/src',
  'libs/iostreams/src',
  'libs/system/src'
]
      
lucene_contrib_source_dirs = [
    top + 'src/contrib'
]

lucene_include_dirs = [
    top + 'include',
    top + 'src/core/include',
    top + 'src/contrib/include'
]

tester_source_dirs = [
    top + 'src/test'
]

tester_include_dirs = [
    top + 'include',
    top + 'src/core/include',
    top + 'src/contrib/include',
    top + 'src/test/include'
]


def options(opt):
    opt.tool_options("boost")
    opt.tool_options('compiler_cxx')
    opt.tool_options('clang', tooldir = 'build')
    opt.add_option(
        '--debug', 
        default = False,
        action = "store_true",
        help ='debug build no optimization, etc...', 
        dest = 'debug')
    
    opt.add_option(
        '--static', 
        default = False,
        action = "store_true",
        help ='fully static build', 
        dest = 'static')
        
    opt.add_option(
        '--boost', 
        default = 'boost_1_42_0',
        action = "store",
        help ='boost path', 
        dest = 'BOOST_HOME')


def configure(conf):
    conf.env['INCLUDES_BOOST'] = Options.options.BOOST_HOME
    
    conf.check_tool('g++')
    conf.check_tool('gcc')
    #now try with overridden clang...
    conf.check_tool('clang', 'build')
    conf.check_cc(lib = 'pthread', mandatory = True)
    conf.check(header_name='bzlib.h', mandatory = True)
    conf.env['LINKFLAGS_cshlib'] = ''
    conf.env['LINKFLAGS_cxxshlib'] = ''
    
    conf.check_tool('boost')
    conf.check_tool('clang', 'build')
    conf.check_boost(
        #static = 'onlystatic',
        lib = ['filesystem', 'thread', 'regex', 'system', 'date_time', 'iostreams', 'unit_test_framework']
    )
    
    if conf.env['HAVE_LLVM'] == False:
      raise Exception("No clang found")
    #if conf.path.find_dir(conf.env['INCLUDES_BOOST'] + "/libs") == None:
    #  raise Exception(conf.env['INCLUDES_BOOST'] + " does not have the libs directory or is not within the source path (" + top + ") - check that the path is correctly and points to a source distribution")
    #if conf.path.find_dir(conf.env['INCLUDES_BOOST'] + "/boost") != None:
    #  raise Exception("Please remove the boost includes path, it causes problems for some unknown reason")

def build(bld):
    target_type = 'cxxstlib'
    debug_define = '_DEBUG' if Options.options.debug else 'NDEBUG'
    compile_flags = ['-emit-llvm']
    if Options.options.debug:
         compile_flags = compile_flags + ['-O0', '-g', ] 
    else:
         compile_flags = compile_flags + ['-O3']
    
    dll_link_flags = ['-link-as-library']
    app_link_flags = ['-native', 
                      'scripts/llvm/liblucene++.a',
                      '-L/usr/lib/gcc/x86_64-linux-gnu/4.5/',
                      '-lsupc++', '-lstdc++', 
                      '-lpthread', '-lm', '-lc'
    ]
    #                        'scripts/llvm/liblucene_boost.a',  
    #                        
    #                        

    ###############
    #libraries...
    ###############
    
    lucene_sources = []
    for source_dir in lucene_source_dirs:
        source_dir = bld.path.find_dir(source_dir)
        lucene_sources.extend(source_dir.ant_glob(source_patterns))
    bld(
        name = 'lucene++',
        features = ['cxx', 'c'] + [target_type],
        source = [source.relpath_gen(bld.path) for source in lucene_sources],
        target = 'lucene++',
        includes = lucene_include_dirs + [bld.env["INCLUDES_BOOST"]],
        cflags = compile_flags,
        cxxflags = compile_flags,
        linkflags = dll_link_flags,
        defines = ['LPP_BUILDING_LIB', 'LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD'
        )
    
    lucene_contrib_sources = []
    for source_dir in lucene_contrib_source_dirs:
        source_dir = bld.path.find_dir(source_dir)
        lucene_contrib_sources.extend(source_dir.ant_glob(source_patterns))
    bld(
        name = 'lucene_contrib',
        features = ['cxx', 'c'] + [target_type],
        source = [source.relpath_gen(bld.path) for source in lucene_contrib_sources],
        target = 'lucene_contrib',
        includes = lucene_include_dirs + [bld.env["INCLUDES_BOOST"]],
        cflags = compile_flags,
        cxxflags = compile_flags,
        linkflags = dll_link_flags,
        defines = ['LPP_BUILDING_LIB', 'LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        )
    
    
    #lucene_boost_sources = []
    #for source_dir in boost_sources_dirs:
    #    if not bld.path.find_dir(bld.env["INCLUDES_BOOST"] + "/" + source_dir):
    #      raise Exception(source_dir + " was not found or is not inside the lucene path")
    #    source_dir = bld.path.find_dir(bld.env["INCLUDES_BOOST"] + "/" + source_dir)
    #    lucene_boost_sources.extend(source_dir.ant_glob(source_patterns, excl='win32'))
    #bld(
    #    name = 'lucene_boost',
    #    features = ['cxx', 'c'] + [target_type],
    #    source = [source.relpath_gen(bld.path) for source in lucene_boost_sources],
    #    target = 'lucene_boost',
    #    includes = bld.env["INCLUDES_BOOST"],
    #    cflags = compile_flags,
    #    cxxflags = compile_flags,
    #    linkflags = dll_link_flags,
    #    defines = [debug_define] + boost_defines,
    #)
    
    ##########
    # applications
    ##########

    tester_sources = []
    for source_dir in tester_source_dirs:
        source_dir = bld.path.find_dir(source_dir)
        tester_sources.extend(source_dir.ant_glob(source_patterns))
    
    #bld(
    #    name = 'lucene_tester',
    #    features = ['cxx', 'c', 'cprogram'],
    #    #source = [source.relpath_gen(bld.path) for source in tester_sources],
    #    target = 'lucene_tester',
    #    includes = tester_include_dirs + [bld.env["INCLUDES_BOOST"]],
    #    cflags = compile_flags,
    #    cxxflags = compile_flags,
    #    linkflags = app_link_flags,
    #    defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + ['LPP_EXPOSE_INTERNAL'] + [debug_define],
    #    uselib = 'PTHREAD',
    #    use = 'lucene++ lucene_contrib'
    #    )
    
    bld(
        name = 'deletefiles',
        features = ['cxx', 'c', 'cprogram'],
        source = bld.path.find_resource(top + 'src/demo/deletefiles/main.cpp').relpath_gen(bld.path),
        target = 'deletefiles',
        includes = [top + 'include'] + [bld.env["INCLUDES_BOOST"]],
        cflags = compile_flags,
        cxxflags = compile_flags,
        linkflags = app_link_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD',
        uselib_local = 'lucene++'
        )

    bld(
        name = 'indexfiles',
        features = ['cxx', 'c', 'cprogram'],
        source = bld.path.find_resource(top + 'src/demo/indexfiles/main.cpp').relpath_gen(bld.path),
        target = 'indexfiles',
        includes = [top + 'include'] + [bld.env["INCLUDES_BOOST"]],
        cflags = compile_flags,
        cxxflags = compile_flags,
        linkflags = app_link_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD',
        uselib_local = 'lucene++'
        )
        
    bld(
        name = 'searchfiles',
        features = ['cxx', 'c', 'cprogram'],
        source = bld.path.find_resource(top + 'src/demo/searchfiles/main.cpp').relpath_gen(bld.path),
        target = 'searchfiles',
        includes = [top + 'include'] + [bld.env["INCLUDES_BOOST"]],
        cflags = compile_flags,
        cxxflags = compile_flags,
        linkflags = app_link_flags,
        defines = ['LPP_HAVE_GXXCLASSVISIBILITY'] + [debug_define],
        uselib = 'BOOST_FILESYSTEM BOOST_THREAD BOOST_REGEX BOOST_SYSTEM BOOST_DATE_TIME BOOST_IOSTREAMS PTHREAD',
        uselib_local = 'lucene++'
        )
        
        
        #Todo:
        #llvm-ld -native *.so target.bc -o ntv -lsupc++ -lstdc++ -L/usr/lib/llvm-2.8/gcc-4.2/lib64 -lpthread

=== src/contrib/CMakeLists.txt ===
project(lucene++-contrib)

####################################
# THE lucene++-contrib library
####################################
file(GLOB_RECURSE lucene_sources
  ${lucene++-contrib_SOURCE_DIR}/*.cpp
  ${lucene++-contrib_SOURCE_DIR}/snowball/libstemmer_c/libstemmer/libstemmer_utf8.c
  ${lucene++-contrib_SOURCE_DIR}/snowball/libstemmer_c/src_c/*.c
  ${lucene++-contrib_SOURCE_DIR}/snowball/libstemmer_c/runtime/*.c)
file(GLOB_RECURSE HEADERS ${lucene++-contrib_SOURCE_DIR}/include/*.h)

ADD_DEFINITIONS(-DLPP_BUILDING_LIB)
INCLUDE_DIRECTORIES(${lucene++-base_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${lucene++-lib_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${lucene++-contrib_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

install(FILES ${HEADERS}
		        DESTINATION include/lucene++
		        COMPONENT development-contrib)

#################################
# lucene++ static library
#################################
ADD_LIBRARY(lucene++-contrib-static STATIC EXCLUDE_FROM_ALL
	${lucene_sources} ${HEADERS}
)
#set properties on the libraries
SET_TARGET_PROPERTIES(lucene++-contrib-static PROPERTIES
    VERSION ${LUCENE++_VERSION}
    SOVERSION ${LUCENE++_SOVERSION}
)

#################################
# lucene++ shared library
#################################
SET(PCH_ADDITIONAL_COMPILER_FLAGS_lucene++-contrib -DLPP_HAVE_DLL)
ADD_LIBRARY(lucene++-contrib SHARED
	${lucene_sources} ${HEADERS}
)
#set properties on the libraries
SET_TARGET_PROPERTIES(lucene++-contrib PROPERTIES
    VERSION ${LUCENE++_VERSION}
    SOVERSION ${LUCENE++_SOVERSION}
    COMPILE_FLAGS -DLPP_HAVE_DLL
)
TARGET_LINK_LIBRARIES(lucene++-contrib 
  ${CMAKE_THREAD_LIBS_INIT}
  lucene++)
install(TARGETS lucene++-contrib
	        DESTINATION ${LIB_DESTINATION} 
	        COMPONENT runtime )

=== src/core/CMakeLists.txt ===
PROJECT (lucene++-lib)

####################################
# THE lucene++ library
####################################
file(GLOB_RECURSE lucene_sources
  ${lucene++-lib_SOURCE_DIR}/search/*.cpp
  ${lucene++-lib_SOURCE_DIR}/analysis/*.cpp
  ${lucene++-lib_SOURCE_DIR}/document/*.cpp
  ${lucene++-lib_SOURCE_DIR}/index/*.cpp
  ${lucene++-lib_SOURCE_DIR}/queryparser/*.cpp
  ${lucene++-lib_SOURCE_DIR}/store/*.cpp
  ${lucene++-lib_SOURCE_DIR}/util/*.cpp)

file(GLOB_RECURSE INTERN_HEADERS ${lucene++-libs_SOURCE_DIR}/include/*.h)
file(GLOB_RECURSE HEADERS ${lucene++-base_SOURCE_DIR}/include/*.h
                          ${lucene++-base_BINARY_DIR}/include/*.h)

#C sources...
file(GLOB_RECURSE lucene_c_sources
  ${lucene++-lib_SOURCE_DIR}/util/*.c)

  
IF ( ENABLE_NEDMALLOC )
  ADD_DEFINITIONS(-DLPP_USE_NEDMALLOC)
ENDIF()

LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${lucene++-base_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${lucene++-lib_SOURCE_DIR}/include)
ADD_DEFINITIONS(-DLPP_BUILDING_LIB)
ADD_LIBRARY(lucene++-c STATIC
	${lucene_c_sources}
)
install(FILES ${HEADERS}
		        DESTINATION include/lucene++
		        COMPONENT development)

#################################
# lucene++ shared library
#################################
ADD_LIBRARY(lucene++ SHARED
	${lucene_sources} ${HEADERS} ${INTERN_HEADERS}
)
SET(PCH_ADDITIONAL_COMPILER_FLAGS_lucene++ -DLPP_HAVE_DLL)
ADD_PRECOMPILED_HEADER(lucene++ ${lucene++-lib_SOURCE_DIR}/include/LuceneInc.h)
#set properties on the libraries
SET_TARGET_PROPERTIES(lucene++ PROPERTIES
    VERSION ${LUCENE++_VERSION}
    SOVERSION ${LUCENE++_SOVERSION}
    COMPILE_FLAGS -DLPP_HAVE_DLL
)
TARGET_LINK_LIBRARIES(lucene++ 
  lucene++-c 
  ${CMAKE_THREAD_LIBS_INIT}
  ${LUCENE_BOOST_LIBS} )
install(TARGETS lucene++
	        DESTINATION ${LIB_DESTINATION} 
	        COMPONENT runtime)

#################################
# lucene++ static library
#################################
ADD_LIBRARY(lucene++-static STATIC EXCLUDE_FROM_ALL
	${lucene_sources} ${HEADERS} ${INTERN_HEADERS}
)
ADD_PRECOMPILED_HEADER(lucene++-static ${lucene++-lib_SOURCE_DIR}/include/LuceneInc.h)
#set properties on the libraries
SET_TARGET_PROPERTIES(lucene++-static PROPERTIES
    VERSION ${LUCENE++_VERSION}
    SOVERSION ${LUCENE++_SOVERSION}
)

=== src/demo/CMakeLists.txt ===
project(lucene++-demo)

####################################
# THE lucene++demo applications
####################################
file(GLOB_RECURSE HEADERS ${lucene++-demo_SOURCE_DIR}/../include/*.h)
ADD_DEFINITIONS(-DLPP_HAVE_DLL)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${lucene++-base_SOURCE_DIR}/include)

ADD_EXECUTABLE(indexfiles EXCLUDE_FROM_ALL
	${lucene++-demo_SOURCE_DIR}/indexfiles/main.cpp ${HEADERS}
)
TARGET_LINK_LIBRARIES(indexfiles lucene++)

ADD_EXECUTABLE(searchfiles EXCLUDE_FROM_ALL
	${lucene++-demo_SOURCE_DIR}/searchfiles/main.cpp ${HEADERS}
)
TARGET_LINK_LIBRARIES(searchfiles lucene++)

ADD_EXECUTABLE(deletefiles EXCLUDE_FROM_ALL
	${lucene++-demo_SOURCE_DIR}/deletefiles/main.cpp ${HEADERS}
)
TARGET_LINK_LIBRARIES(deletefiles lucene++)

ADD_CUSTOM_TARGET(
   demo
   DEPENDS indexfiles searchfiles deletefiles
)

=== src/test/CMakeLists.txt ===
project(lucene++-tester)

####################################
# THE lucene++tester library
####################################
file(GLOB_RECURSE lucene_sources
  ${lucene++-tester_SOURCE_DIR}/*.cpp)
file(GLOB_RECURSE HEADERS ${lucene++-tester_SOURCE_DIR}/../include/*.h)
file(GLOB_RECURSE HEADERS ${lucene++-tester_SOURCE_DIR}/include/*.h)

LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${lucene++-base_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${lucene++-lib_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${lucene++-contrib_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${lucene++-tester_SOURCE_DIR}/include)
ADD_DEFINITIONS(-DLPP_EXPOSE_INTERNAL)

ADD_EXECUTABLE(lucene++-tester EXCLUDE_FROM_ALL
	${lucene_sources} ${HEADERS}
)

#set properties on the libraries
SET_TARGET_PROPERTIES(lucene++-tester PROPERTIES
    VERSION ${LUCENE++_VERSION}
    SOVERSION ${LUCENE++_SOVERSION}
)
TARGET_LINK_LIBRARIES(lucene++-tester 
  lucene++-static 
  lucene++-c 
  lucene++-contrib-static 
  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE}
  ${LUCENE_BOOST_LIBS} )

ADD_TEST(lucene++-tester ${EXECUTABLE_OUTPUT_PATH}/lucene++-tester -p --test_dir=${lucene++-tester_SOURCE_DIR}/testfiles)

=== debian/changelog ===
lucene++ (3.0.4-0ubuntu3) trusty; urgency=low

  * No change rebuild against Boost 1.54.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sun, 27 Oct 2013 02:15:20 +0000

lucene++ (3.0.4-0ubuntu2) saucy; urgency=low

  * Remove debian/patches/add_cross_build.diff:
    - It seems we don't need this currently
  * debian/rules:
    - Remove cross-building changes
    - Build using the standard allocator (-DENABLE_STANDARD_ALLOCATOR:BOOL=ON)
  * debian/control:
    - Developer packages depend on -doc
    - Enable multi-arch
    - Minor enhancements
  * Add debian/patches/enable_multiarch.diff:
    - Patch fixing some paths for proper multiarch support

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Thu, 01 Aug 2013 12:38:42 +0200

lucene++ (3.0.4-0ubuntu1) saucy; urgency=low

  * Initial release based on the packaging made by Mathias Hasselmann and
    Ken VanDine
  * Import Ricardo Salveti's package cross-build modifications with slight
    modifications

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Tue, 30 Jul 2013 15:00:47 +0200

=== debian/control ===
Source: lucene++
Priority: optional
Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
XSBC-Original-Maintainer: Mathias Hasselmann <mathias@openismus.com>
Build-Depends: cmake (>= 2.6),
               debhelper (>= 9),
               doxygen (>= 1.2.18),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
Standards-Version: 3.9.4
Section: libs
Homepage: https://github.com/luceneplusplus/LucenePlusPlus
Vcs-Bzr: https://code.launchpad.net/~ubuntu-unity/lucene++/ubuntu
Vcs-Browser: http://bazaar.launchpad.net/~ubuntu-unity/lucene++/ubuntu/files

Package: liblucene++-dev
Section: libdevel
Architecture: any
Depends: liblucene++-contrib0 (= ${binary:Version}),
         liblucene++0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Development files for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains development files

Package: liblucene++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Reference manual for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the reference manual and examples.

Package: liblucene++0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Shared library for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.

Package: liblucene++-contrib0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Shared library with Lucene++ contributions
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This additional contributions include analyzers, a memory-only
 index and a HTML highlighter for search results.

=== debian/watch ===
version=3
http://githubredir.debian.net/github/luceneplusplus/LucenePlusPlus .*/rel_(.+)\.tar\.gz

## lucene++ 3.0.6

=== CMakeLists.txt ===
project(lucene++)

cmake_minimum_required(VERSION 2.8.6)

set(lucene++_VERSION_MAJOR 3)
set(lucene++_VERSION_MINOR 0)
set(lucene++_VERSION_PATCH 6)

set(lucene++_SOVERSION "0")

set(lucene++_VERSION
  "${lucene++_VERSION_MAJOR}.${lucene++_VERSION_MINOR}.${lucene++_VERSION_PATCH}"
)

# include specific modules
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

####################################
# pre-compiled headers support
####################################
include(cotire)

# if setup using the Toolchain-llvm.cmake file, then use llvm...
if(ENABLE_LLVM)
  include(Toolchain-llvm)
endif()

####################################
# user specified build options
####################################
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

option(ENABLE_PACKAGING
  "Create build scripts for creating lucene++ packages"
  OFF
)
option(LUCENE_USE_STATIC_BOOST_LIBS
  "Use static boost libraries"
  OFF
)
option(ENABLE_CYCLIC_CHECK
  "Enable cyclic checking"
  OFF
)

####################################
# bootstrap
####################################

find_package(Subversion REQUIRED)
find_package(Threads REQUIRED)
find_package(Boost COMPONENTS
  date_time
  filesystem
  iostreams
  regex
  system
  thread
  REQUIRED
)

set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_LIBS ${LUCENE_USE_STATIC_BOOST_LIBS})

set(lucene_boost_libs
  ${Boost_LIBRARIES}
  ${Boost_FILESYSTEM_LIBRARIES}
  ${Boost_IOSTREAMS_LIBRARIES}
  ${Boost_REGEX_LIBRARIES}
  ${Boost_SYSTEM_LIBRARIES}
  ${Boost_THREAD_LIBRARIES}
)

include(Lucene++Docs)
include(TestCXXAcceptsFlag)

set(LIB_DESTINATION
  "lib" CACHE STRING "Define lib output directory name"
)

if(ENABLE_CYCLIC_CHECK)
  set(DEFINE_USE_CYCLIC_CHECK "define")
else()
  set(DEFINE_USE_CYCLIC_CHECK "undef")
endif()

####################################
# platform specific options
####################################
if(WIN32 OR WIN64)
  set(CMAKE_DEBUG_POSTFIX "d")
endif()

if(NOT MSVC AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")
  add_definitions(-fPIC)
endif()

if(CYGWIN)
  add_definitions(-D__LARGE64_FILES)
endif()

#################################
# generate Config.h
#################################
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/Config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/include/Config.h @ONLY
)

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}/include
)

include(CMakeExternal.txt)
enable_testing()

add_subdirectory(src/core)
add_subdirectory(src/contrib)
add_subdirectory(src/demo)
add_subdirectory(src/test)

#################################
# install pkg-config file
#################################
if(NOT WIN32)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/liblucene++.pc.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc @ONLY)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/liblucene++-contrib.pc.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc @ONLY)
  install(
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/liblucene++.pc
    ${CMAKE_CURRENT_BINARY_DIR}/liblucene++-contrib.pc
    DESTINATION ${LIB_DESTINATION}/pkgconfig)
endif()

####################################
# custom targets
####################################
configure_file(
  "${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY
)

add_custom_target(
  uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
)

if(ENABLE_PACKAGING)
  include(CreateLucene++Packages)
endif()

message("** Build Summary **")
message("  Version:        ${lucene++_VERSION}")
message("  Prefix:         ${CMAKE_INSTALL_PREFIX}")
message("  Build Type:     ${CMAKE_BUILD_TYPE}")
message("  Architecture:   ${CMAKE_SYSTEM_PROCESSOR}")
message("  System:         ${CMAKE_SYSTEM_NAME}")
message("  Boost Include:  ${Boost_INCLUDE_DIRS}")
message("  Boost Library:  ${Boost_LIBRARY_DIRS}")

=== src/contrib/CMakeLists.txt ===
project(lucene++-contrib)

file(GLOB_RECURSE contrib_sources
  analyzers/*.cpp
  highlighter/*.cpp
  memory/*.cpp
  snowball/*.cpp
  snowball/libstemmer_c/libstemmer/libstemmer_utf8.c
  snowball/libstemmer_c/src_c/*.c
  snowball/libstemmer_c/runtime/*.c
)

file(GLOB_RECURSE contrib_headers
  ${lucene++-contrib_SOURCE_DIR}/include/*.h
)

add_definitions(-DLPP_BUILDING_LIB)

include_directories(
  ${lucene++_SOURCE_DIR}/include
  ${lucene++-lib_SOURCE_DIR}/include
  ${lucene++-contrib_SOURCE_DIR}/include
  ${lucene++-contrib_SOURCE_DIR}/snowball/libstemmer_c/include
  ${Boost_INCLUDE_DIRS}
)

link_directories(
  ${Boost_LIBRARY_DIRS}
)

install(FILES ${contrib_headers}
  DESTINATION
  include/lucene++
  COMPONENT development-contrib
)

add_library(lucene++-contrib SHARED
  ${contrib_sources}
  ${contrib_headers}
)

set_target_properties(lucene++-contrib PROPERTIES
  VERSION ${lucene++_VERSION}
  SOVERSION ${lucene++_SOVERSION}
  COMPILE_FLAGS -DLPP_HAVE_DLL
)

target_link_libraries(lucene++-contrib
  ${CMAKE_THREAD_LIBS_INIT}
  lucene++
)

cotire(lucene++-contrib)

install(TARGETS lucene++-contrib
  DESTINATION ${LIB_DESTINATION}
  COMPONENT runtime
)

=== src/core/CMakeLists.txt ===
project(lucene++-lib)

include_directories(
  ${lucene++_SOURCE_DIR}/include
  ${lucene++-lib_SOURCE_DIR}/include
  ${Boost_INCLUDE_DIRS}
)

file(GLOB_RECURSE lucene_sources
  search/*.cpp
  analysis/*.cpp
  document/*.cpp
  index/*.cpp
  queryparser/*.cpp
  store/*.cpp
  util/*.c*)

file(GLOB_RECURSE lucene_internal_headers
  ${lucene++-lib_SOURCE_DIR}/include/*.h
)

file(GLOB_RECURSE lucene_headers
  include/*.h
)

add_definitions(-DLPP_BUILDING_LIB)

add_library(lucene++ SHARED
  ${lucene_sources}
)

target_link_libraries(lucene++
  ${CMAKE_THREAD_LIBS_INIT}
  ${lucene_boost_libs}
)

set_target_properties(lucene++ PROPERTIES COTIRE_CXX_PREFIX_HEADER_INIT "include/LuceneInc.h")
cotire(lucene++)

set_target_properties(lucene++ PROPERTIES
  VERSION ${lucene++_VERSION}
  SOVERSION ${lucene++_SOVERSION}
  COMPILE_FLAGS -DLPP_HAVE_DLL
)

install(FILES ${lucene_headers}
  DESTINATION include/lucene++
  COMPONENT development
)

install(TARGETS lucene++
  DESTINATION ${LIB_DESTINATION}
  COMPONENT runtime
)

=== src/demo/CMakeLists.txt ===
project(lucene++-demo)

file(GLOB_RECURSE
  demo_headers
  ${lucene++-demo_SOURCE_DIR}/../include/*.h
)

add_definitions(-DLPP_HAVE_DLL)

include_directories(
  ${Boost_INCLUDE_DIRS}
)
include_directories(
  ${lucene++_SOURCE_DIR}/include
)

add_executable(indexfiles
  ${lucene++-demo_SOURCE_DIR}/indexfiles/main.cpp
  ${demo_headers}
)
target_link_libraries(indexfiles
  lucene++
)

add_executable(searchfiles
  ${lucene++-demo_SOURCE_DIR}/searchfiles/main.cpp
  ${demo_headers}
)
target_link_libraries(searchfiles
  lucene++
)

add_executable(deletefiles
  ${lucene++-demo_SOURCE_DIR}/deletefiles/main.cpp
  ${demo_headers}
)
target_link_libraries(deletefiles
  lucene++
)

=== src/test/CMakeLists.txt ===
project(lucene++-tester)

include_directories(
  ${GTEST_INCLUDE_DIR}
  ${lucene++_SOURCE_DIR}/include
  ${lucene++-lib_SOURCE_DIR}/include
  ${lucene++-contrib_SOURCE_DIR}/include
  ${lucene++-tester_SOURCE_DIR}/include
  ${Boost_INCLUDE_DIRS}
)

file(GLOB_RECURSE tester_sources
  analysis/*.cpp
  contrib/*.cpp
  document/*.cpp
  index/*.cpp
  main/*.cpp
  queryparser/*.cpp
  search/*.cpp
  store/*.cpp
  util/*.cpp
)

file(GLOB_RECURSE test_headers
  ${lucene++-tester_SOURCE_DIR}/../include/*.h
  ${lucene++-tester_SOURCE_DIR}/include/*.h
)

add_definitions(-DLPP_EXPOSE_INTERNAL)

link_directories(
  ${GTEST_LIB_DIR}
)

add_executable(lucene++-tester
  ${tester_sources}
  ${test_headers}
)

add_dependencies(lucene++-tester
  googletest
)

target_link_libraries(lucene++-tester
  ${CMAKE_THREAD_LIBS_INIT}
  lucene++
  lucene++-contrib
  gtest
  ${lucene_boost_libs}
)

cotire(lucene++-tester)

=== debian/changelog ===
lucene++ (3.0.6-3) unstable; urgency=medium

  * Do not symlink jquery from doxygen, this will result in a
    broken documentation. cfr: 736360.
    - Drop libjs-jquery and dh-linktree from b-d.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 30 Oct 2014 12:03:59 +0100

lucene++ (3.0.6-2) unstable; urgency=medium

  * debian/patches/fix-build-failure.patch
    - trying to fix both hurd and kfreebsd-* build failures.
  * Bump std-version to 3.9.6, no changes required.
  * Fix some copyright entries.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 10 Oct 2014 19:25:22 +0200

lucene++ (3.0.6-1) unstable; urgency=low

  * Initial release (Closes: #750148).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Mon, 16 Jun 2014 17:48:23 +0200

=== debian/control ===
Source: lucene++
Priority: optional
Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
Uploaders: Gianfranco Costamagna <costamagnagianfranco@yahoo.it>
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/luceneplusplus/LucenePlusPlus

Package: liblucene++-dev
Section: libdevel
Architecture: any
Depends: liblucene++-contrib0 (= ${binary:Version}),
         liblucene++0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains development files.

Package: liblucene++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Reference manual for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the reference manual and examples.

Package: liblucene++0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the shared library.

Package: liblucene++-contrib0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library with Lucene++ contributions
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This additional contributions include analyzers, a memory-only
 index and a HTML highlighter for search results.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ -- --parallel --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_STANDARD_ALLOCATOR:BOOL=ON

override_dh_auto_build-indep:
	dh_auto_configure -- -DENABLE_STANDARD_ALLOCATOR:BOOL=ON -DENABLE_DOCS:BOOL=ON
	dh_auto_build -- doc

override_dh_install-indep:
	dh_install -pliblucene++-doc usr/share/doc/lucene++-3.0.6/* usr/share/doc/liblucene++-doc/html
	rm -rf debian/tmp/usr/share/doc/lucene++-3.0.6/
